<template>
	<div v-if="rollup">
		<component :is="wrapperComponent.is" v-bind="wrapperComponent.props">
			<div :class="[$style.starsWrapper, $style.star]">
				<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 120 19">
					<defs>
						<clipPath :id="`cut-off-star-${randomId}`">
							<rect x="1.1" y="0" :width="((stars % 20) / 20) * 17.5" height="19" />
						</clipPath>
					</defs>
					<g v-for="n in 5" :key="n">
						<path
							v-if="n * 20 > stars"
							d="M16.16,19,10,15.75,3.81,19,5,12.12,0,7.26l6.9-1L10,0l3.08,6.25,6.91,1-5,4.86ZM10,14.62l4.84,2.55-.92-5.4L17.83,8l-5.42-.78L10,2.26,7.57,7.17,2.15,8l3.92,3.82-.93,5.4Z"
						/>
						<polygon
							v-if="n * 20 <= stars || stars > (n - 1) * 20"
							:clip-path="stars / 20 < n ? `url(#cut-off-star-${randomId})` : null"
							points="9.99 15.75 3.81 19 4.99 12.12 0 7.25 6.9 6.25 9.99 0 13.07 6.25 19.98 7.25 14.98 12.12 16.16 19 9.99 15.75"
							fill-rule="evenodd"
						/>
					</g>
				</svg>
			</div>
			<div :class="[$style.text, { [$style.inheritTextAlign]: inheritTextAlign }]">
				{{ rollup.review_count | numberWithCommas }} reviews / {{ ratingToDisplay }} stars
			</div>
		</component>
	</div>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
	props: {
		pageId: {
			type: String,
			default: '',
		},

		link: {
			type: String,
			default: '',
		},

		inheritTextAlign: {
			type: Boolean,
			default: false,
		},
	},

	data: () => ({ randomId: Math.floor(Math.random() * 1000000000) }),

	computed: {
		...mapGetters('reviews', ['reviewsSnippetsById']),

		rollup() {
			const { reviewsSnippetsById, pageId } = this;
			return reviewsSnippetsById[pageId] && reviewsSnippetsById[pageId].rollup;
		},

		stars() {
			const { rollup } = this;
			if (!rollup) return 0;
			// 120px = 5 stars * 20px + 4 * 5px spacing
			// but we're taking 2.5px for the empty outline
			const star = 15 / 120;
			const spacing = 5 / 120;
			const outline = 2.5 / 120;
			const rating = this.rollup.average_rating;
			const outlines = Math.floor(rating) * 2 + (rating % 1 ? 1 : 0);
			return (rating * star + spacing * Math.floor(rating) + outline * outlines) * 100;
		},

		wrapperComponent() {
			const { link, $style } = this;
			if (!link) {
				return { is: 'div', props: { class: $style.linkWrapper } };
			} else {
				return {
					is: 'nuxt-link',
					props: {
						to: link,
						class: $style.linkWrapper,
					},
				};
			}
		},

		ratingToDisplay() {
			const { average_rating: rating = 0 } = this.rollup || {};
			return rating.toFixed(rating % 1 === 0 ? 0 : 1);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

@mixin move-stars($distance) {
	@for $i from 3 to 7 {
		&:nth-child(#{$i}) {
			path,
			polygon {
				transform: translateX($distance * ($i - 2));
			}
		}
	}
}

.linkWrapper {
	color: inherit;
}

.star g {
	@include move-stars(25.34px);
}

.starsWrapper {
	position: relative;
	width: 12rem;
	height: 2rem;

	svg {
		display: block;
		width: 12rem;
		max-width: none;
		height: 2rem;
		fill: currentColor;
	}
}

.text {
	font-size: 1.2rem;
	line-height: 2.6rem;
	text-align: center;

	&.inheritTextAlign {
		text-align: inherit;
	}
}
</style>
